precision highp float;

uniform sampler2D sTexture;

uniform float angle;

varying float lum;

void main() {
    vec2 uv = vec2(gl_PointCoord.x, 1.0 - gl_PointCoord.y);

    vec4 shape;

    if(lum > 0.5){
        uv -= vec2(0.5);
        uv *= mat2(cos(angle), -sin(angle), sin(angle), cos(angle));
        uv += vec2(0.5);
        shape = texture2D(sTexture, uv);
    }
    gl_FragColor = shape;


}